<?php
/**
 * @copyright	Copyright (c) 2019 Hikashop Easyparcel Shipping Plugin. All rights reserved.
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 */

// no direct access
defined('_JEXEC') or die;

jimport('joomla.plugin.plugin');

/**
 * hikashopshipping - easyparcel Plugin
 *
 * @package		Joomla.Plugin
 * @subpakage	Hikashop Easyparcel Shipping Plugin.easyparcel
 */
class plgHikashopshippingeasyparcel extends hikashopShippingPlugin 
//JPlugin 
{
	var $multiple = true;
	var $name = 'easyparcel';
	var $pluginConfig = array(
		'customerid' => array('Action ID', 'input'),
		'passphrase' => array('API Key', 'input'),
		'url' => array('Url', 'input'),
		'disable' => array('Diabled method (eg.poslaju, nationwide, etc)', 'input'),
		'pick_code' => array('Pick Postal Code','input'),
		'pick_state' => array('Pick State Code','input'),
		'pick_country' => array('Pick Country Code','input')
		);

	/**
	 * Constructor.
	 *
	 * @param 	$subject
	 * @param	array $config
	*/
	 //function __construct(&$subject, $config = array()) {
	 //	 call parent constructor
	 //	parent::__construct($subject, $config);
	// }

	public function onShippingDisplay(&$order,&$methods,&$usable_methods,&$messages){
		//print_r($methods[5]->shipping_params);


		$input = JFactory::getApplication()->input;

		// should be article, categories, featured, blog...
		$view = $input->get('view'); 



		if(!hikashop_loadUser())
			return false;

		//$ret = parent::onShippingDisplay($order, $dbrates, $local_usable_rates, $local_messages);
		$ret = parent::onShippingDisplay($order, $methods, $usable_methods, $messages);

		//if($view!='checkout'){
		//	return false;
		//}

		//if(!strpos($_SERVER['REQUEST_URI'],'cid-3')){
			//SHOW SOMETHING ONLY FOR STEP 1
		//	return false;
		//}		

		$send_state = 'jhr';
		if (substr_count($order->shipping_address->address_state[0], "Johor")>=1) {
			$send_state = "jhr";
		}
		if (substr_count($order->shipping_address->address_state[0], "Kedah")>=1) {
			$send_state = "kdh";
		}		
		if (substr_count($order->shipping_address->address_state[0], "Kelantan")>=1) {
			$send_state = "ktn";
		}
		if (substr_count($order->shipping_address->address_state[0], "Melaka")>=1) {
			$send_state = "mlk";
		}
		if (substr_count($order->shipping_address->address_state[0], "Sembilan")>=1) {
			$send_state = "nsn";
		}
		if (substr_count($order->shipping_address->address_state[0], "Pahang")>=1) {
			$send_state = "phg";
		}
		if (substr_count($order->shipping_address->address_state[0], "Perak")>=1) {
			$send_state = "prk";
		}
		if (substr_count($order->shipping_address->address_state[0], "Perlis")>=1) {
			$send_state = "pls";
		}
		if (substr_count($order->shipping_address->address_state[0], "Pinang")>=1) {
			$send_state = "png";
		}	
		if (substr_count($order->shipping_address->address_state[0], "Selangor")>=1) {
			$send_state = "sgr";
		}	
		if (substr_count($order->shipping_address->address_state[0], "Terengganu")>=1) {
			$send_state = "trg";
		}	
		if (substr_count($order->shipping_address->address_state[0], "Kuala")>=1) {
			$send_state = "kul";
		}	
		if (substr_count($order->shipping_address->address_state[0], "Putra")>=1) {
			$send_state = "pjy";
		}		
		if (substr_count($order->shipping_address->address_state[0], "Sarawak")>=1) {
			$send_state = "srw";
		}	
		if (substr_count($order->shipping_address->address_state[0], "Sabah")>=1) {
			$send_state = "sbh";
		}	
		if (substr_count($order->shipping_address->address_state[0], "Labuan")>=1) {
			$send_state = "lbn";
		}	
		//echo $send_state;

		$send_country = "MY";
		if (substr_count($order->shipping_address->address_country[0], "Malaysia")>=1) {
			$send_country = "MY";
		}
        if (substr_count($order->shipping_address->address_country[0], "Singapore")>=1)  {
        $send_country = "SG"; }
        if (substr_count($order->shipping_address->address_country[0], "Taiwan")>=1)  {
        $send_country = "TW"; }
        if (substr_count($order->shipping_address->address_country[0], "United Kingdom")>=1)  {
        $send_country = "GB"; }
        if (substr_count($order->shipping_address->address_country[0], "Australia")>=1)  {
        $send_country = "AU"; }
        if (substr_count($order->shipping_address->address_country[0], "Afghanistan")>=1)  {
        $send_country = "AF"; }
        if (substr_count($order->shipping_address->address_country[0], "Argentina")>=1)  {
        $send_country = "AR"; }
        if (substr_count($order->shipping_address->address_country[0], "Austria")>=1)  {
        $send_country = "AT"; }
        if (substr_count($order->shipping_address->address_country[0], "Brazil")>=1)  {
        $send_country = "BR"; }
        if (substr_count($order->shipping_address->address_country[0], "Cambodia")>=1)  {
        $send_country = "KH"; }
        if (substr_count($order->shipping_address->address_country[0], "Canada")>=1)  {
        $send_country = "CA"; }
        if (substr_count($order->shipping_address->address_country[0], "Colombia")>=1)  {
        $send_country = "CO"; }
        if (substr_count($order->shipping_address->address_country[0], "Denmark")>=1)  {
        $send_country = "DK"; }
        if (substr_count($order->shipping_address->address_country[0], "Egypt")>=1)  {
        $send_country = "EG"; }
        if (substr_count($order->shipping_address->address_country[0], "France")>=1)  {
        $send_country = "FR"; }
        if (substr_count($order->shipping_address->address_country[0], "Germany")>=1)  {
        $send_country = "DE"; }
        if (substr_count($order->shipping_address->address_country[0], "Hong Kong")>=1)  {
        $send_country = "HK"; }
        if (substr_count($order->shipping_address->address_country[0], "India")>=1)  {
        $send_country = "IN"; }
        if (substr_count($order->shipping_address->address_country[0], "Indonesia")>=1)  {
        $send_country = "ID"; }
        if (substr_count($order->shipping_address->address_country[0], "Iraq")>=1)  {
        $send_country = "IQ"; }
        if (substr_count($order->shipping_address->address_country[0], "Italy")>=1)  {
        $send_country = "IT"; }
        if (substr_count($order->shipping_address->address_country[0], "Japan")>=1)  {
        $send_country = "JP"; }
        if (substr_count($order->shipping_address->address_country[0], "Jordan")>=1)  {
        $send_country = "JO"; }
        if (substr_count($order->shipping_address->address_country[0], "Macau")>=1)  {
        $send_country = "MO"; }
        if (substr_count($order->shipping_address->address_country[0], "Maldives")>=1)  {
        $send_country = "MV"; }
        if (substr_count($order->shipping_address->address_country[0], "Mexico")>=1)  {
        $send_country = "MX"; }
        if (substr_count($order->shipping_address->address_country[0], "Myanmar")>=1)  {
        $send_country = "MM"; }
        if (substr_count($order->shipping_address->address_country[0], "New Zealand")>=1)  {
        $send_country = "NZ"; }
        if (substr_count($order->shipping_address->address_country[0], "Nigeria")>=1)  {
        $send_country = "NG"; }
        if (substr_count($order->shipping_address->address_country[0], "Pakistan")>=1)  {
        $send_country = "PK"; }
        if (substr_count($order->shipping_address->address_country[0], "Philippines")>=1)  {
        $send_country = "PE"; }
        if (substr_count($order->shipping_address->address_country[0], "Portugal")>=1)  {
        $send_country = "PT"; }
        if (substr_count($order->shipping_address->address_country[0], "Saudi Arabia")>=1)  {
        $send_country = "SA"; }
        if (substr_count($order->shipping_address->address_country[0], "Spain")>=1)  {
        $send_country = "ES"; }
        if (substr_count($order->shipping_address->address_country[0], "Sri Lanka")>=1)  {
        $send_country = "LK"; }
        if (substr_count($order->shipping_address->address_country[0], "Switzerland")>=1)  {
        $send_country = "CH"; }
        if (substr_count($order->shipping_address->address_country[0], "Thailand")>=1)  {
        $send_country = "TH"; }
        if (substr_count($order->shipping_address->address_country[0], "Turkey")>=1)  {
        $send_country = "TR"; }
        if (substr_count($order->shipping_address->address_country[0], "United States")>=1)  {
        $send_country = "US"; }
        if (substr_count($order->shipping_address->address_country[0], "Vietnam")>=1)  {
        $send_country = "VN"; }		

		if ($order->weight<=0){
			$order->weight = "1";
		}

		//print_r($order->weight);
		//print "<pre>";
		//print_r($methods);
		//print "</pre>";
		//echo "test";


		foreach ($usable_methods as $id => $newmethods) {
			if($newmethods->shipping_type == 'easyparcel') {
				//array_push($usable_methods, $newmethods);
					$unsetid=$id;
				$postparam = array(
					'api'	=> $newmethods->shipping_params->passphrase,
					'bulk'	=> array(
					array(
					'pick_code'	=> $newmethods->shipping_params->pick_code,
					'pick_state'	=> $newmethods->shipping_params->pick_state,
					'pick_country'	=> $newmethods->shipping_params->pick_country,
					'send_code'	=> $order->shipping_address->address_post_code,
					'send_state'	=> $send_state,
					'send_country'	=> $send_country,
					'weight'	=> $order->weight,
					),

					),
					); 


				

				$data = $this->easycurl($newmethods->shipping_params->url.$newmethods->shipping_params->customerid,$postparam);
				//print_r($newmethods->shipping_params->customerid);
				//print_r($newmethods->shipping_params->passphrase);
				//print_r($newmethods->shipping_params->url);
				//print_r($newmethods->shipping_params->pick_code);
				//print_r($newmethods->shipping_params->pick_state);
				//print_r($newmethods->shipping_params->pick_country);
				print_r($view);

				$data = json_decode($data);
				//print_r($data->result->rates);
				if ($data->api_status =='Success'){

					foreach ($data->result as $result) {

						foreach ($result->rates as $key => $value) {
							//print "<pre>";
							//print_r($value);
							//print "</pre>";

							$insertmethod[$key]->shipping_id = $value->service_id;
							$insertmethod[$key]->shipping_published = '1';
							$insertmethod[$key]->shipping_price = $value->price;
							//$insertmethod[$key]->shipping_price = '7.00000';
							$insertmethod[$key]->shipping_type = 'easyparcel';
							//$insertmethod[$key]->shipping_type = $value->courier_name;
							$insertmethod[$key]->shipping_name = $value->courier_name;
							$insertmethod[$key]->shipping_currency_id = '96';
							$insertmethod[$key]->shipping_params = $postparam;
							//$insertmethod[$key]->shipping_description = $value->service_name;

							array_push($usable_methods, $insertmethod[$key]);
							unset($usable_methods[$unsetid]);
						}
					}

					//array_push($usable_methods, $insertmethod);

					//print "<pre>";
					//print_r($postparam);
					//print_r($insertmethod);
					//print_r($usable_methods);
					//print "</pre>";
					}
				}
		}

		// foreach($usable_rates as $k => $rate) {
		// 	if($rate->shipping_type != $this->name) {

		// 	}
		// }
		
		//foreach ($usable_methods as &$methods) {
			// print_r($methods->shipping_price);
			// print_r($methods->shipping_type);
			// print_r($this->name);
			// print_r($order->weight);
			// print_r($order->shipping_address);

			//$methods->shipping_price = '20';
						
			//$myfile = fopen("shippingdisp2.txt", "w") or die("Unable to open file!");
			//fwrite($myfile,print_r($methods,true));


			//$myfile = fopen("shippingdisp.txt", "w") or die("Unable to open file!");
			//fwrite($myfile,print_r($usable_methods,true));
		//}

	}

	private function _curl($url, $fields) {
		$ch = curl_init();

		$fields_string = '';
		foreach($fields as $key => $value) {
			$fields_string .= $key . '=' . $value . '&';
		}
		rtrim($fields_string, '&');

		curl_setopt($ch, CURLOPT_AUTOREFERER, true);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($ch, CURLOPT_POST, count($fields));
		curl_setopt($ch, CURLOPT_POSTFIELDS, $fields_string);

		$data = curl_exec($ch);
		curl_close($ch);

		return $data;
	}

	private function easycurl($url, $postparam) {
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($postparam));
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);

		ob_start(); 
		$return = curl_exec($ch);
		ob_end_clean();
		curl_close($ch);


		return $return;
	}	

	function getShippingDefaultValues(&$element){
		$element -> shipping_name = 'easyparcel';
		$element -> shipping_description = '';
		$element -> group_package = 0;
		$element -> shipping_images = 'easyparcel';
		$element -> shipping_params -> post_code = '';
		$element -> shipping_currency_id = $this -> main_currency;
	}

	function shippingMethods(&$main){
		$methods = array();
		if(!empty($main->shipping_params->methodsList)) {
			$main->shipping_params->methods = hikashop_unserialize($main->shipping_params->methodsList);
		}
		if(!empty($main->shipping_params->methods)) {
			foreach($main->shipping_params->methods as $method){
				$selected = null;
				foreach($this->fedex_methods as $fedex) {
					if($fedex['code'] == $method) {
						$selected = $fedex;
						break;
					}
				}
				if($selected)
					$methods[$main->shipping_id . '-' . $selected['key']] = $selected['name'];
			}
		}
		return $methods;
	}		
	
}